#include "apilib.h"
#include <stdio.h>

#define RGB(r,g,b)		16 + r + g * 6 + b * 36

void Screen(int win);

void HariMain(void)
{
	char *buf, s[7];
	struct TIME_INFO *tinfo;
	int win;
	int key;

	api_initmalloc();
	buf = api_malloc(300 * 200);
	win = api_openwin(buf, 300, 200, -1, "Ă");	

	Screen(win);
	tomo_systime(tinfo);
	sprintf(s, "%02X", tinfo->hour);
	api_putstrwin(win, 6 + 9 + 2, 27 + 9 + 2, 17, 7, s);

	key = api_getkey(1);
	if (key == 'a')
	{
		Screen(win);
		api_getkey(1);
	}

	api_end();
}

void Screen(int win)
{
	api_boxfilwin(win, 6, 27, 300 - 8, 200 - 8, 15);
	api_boxfilwin(win, 6+8, 27+8, 300 - 16, 200 - 16, 0);
	api_boxfilwin(win, 6+9, 27+9, 300 - 17, 200 - 17, 7);
	return;
}
