#include "../main/bootpack.h"
unsigned char rgb2pal(int r, int g, int b, int x, int y);

int Total_WinMax = 0;
#define TaskBarStr 16
#define	TaskBarItem 10
#define TaskBar_Window_Size TaskBarStr*8

void load_screen8(int *fat, unsigned char *vram, int x, int y)
{	/* ǎ̓ǂݍ */
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	unsigned char *filebuf, r, g, b;
	struct DLL_STRPICENV env;
	struct RGB *picbuf;
	int info[4], fsize, xx, yy;
	struct FILEINFO *finfo = file_search("logo.jpg", (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);

	boxfill8(vram, x, COL8_000000,  0,     0,      x -  1,      y);

	fsize   = finfo->size;
	filebuf = (unsigned char *) memman_alloc_4k(memman, fsize);
	filebuf = file_loadfile2(finfo->clustno, &fsize, fat);
	info_JPEG(&env, info, fsize, filebuf);
	picbuf  = (struct RGB *) memman_alloc_4k(memman, info[2] * info[3] * sizeof(struct RGB));
	decode0_JPEG(&env, fsize, filebuf, 4, (unsigned char *) picbuf, 0);
	for (yy = 0; yy < info[3]; yy++) {
		for (xx = 0; xx < info[2]; xx++) {
			r = picbuf[yy * info[2] + xx].r;
			g = picbuf[yy * info[2] + xx].g;
			b = picbuf[yy * info[2] + xx].b;
			vram[(yy) * x + (xx)] = rgb2pal(r, g, b, xx, yy);
		}
	}
	return;
}

void init_screen8(int *fat, unsigned char *vram, int x, int y)
{
	/* ǎ̓ǂݍ */
	struct BOOTINFO *binfo = (struct BOOTINFO *) ADR_BOOTINFO;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	unsigned char *filebuf, r, g, b;
	struct DLL_STRPICENV env;
	struct RGB *picbuf;
	int info[4], fsize, xx, yy;
	struct FILEINFO *finfo = file_search(OS_WALLJPG, (struct FILEINFO *) (ADR_DISKIMG + 0x002600), 224);

	if (binfo->vmode == 16 && finfo != 0) {
		fsize   = finfo->size;
		filebuf = (unsigned char *) memman_alloc_4k(memman, fsize);
		filebuf = file_loadfile2(finfo->clustno, &fsize, fat);
		info_JPEG(&env, info, fsize, filebuf);
		picbuf  = (struct RGB *) memman_alloc_4k(memman, info[2] * info[3] * sizeof(struct RGB));
		decode0_JPEG(&env, fsize, filebuf, 4, (unsigned char *) picbuf, 0);
		for (yy = 0; yy < info[3]; yy++) {
			for (xx = 0; xx < info[2]; xx++) {
				r = picbuf[yy * info[2] + xx].r;
				g = picbuf[yy * info[2] + xx].g;
				b = picbuf[yy * info[2] + xx].b;
				vram[yy * x + xx] = rgb2pal(r, g, b, xx, yy);
			}
		}
	} else {
		boxfill8(vram, x, COL8__LIGHT,  0,     0,      x -  1,      y);
	}

	//^XNo[
	if (DT_TASKBAR == 1) {
		boxfill8(vram, x, COL8_FFFFFF ,0,y - 30, x, y - 30);
		boxfill8(vram, x, COL8___BASE ,0,y - 29, x,  y - 1);
	}

	return;	
}

void init_mouse_cursor8(char *mouse, char bc)
/* }EXJ[\i16x16j */
{
	static char cursor[16][16] = {
		"*...............",
		"**..............",
		"*O*.............",
		"*OO*............",
		"*OOO*...........",
		"*OOOO*..........",
		"*OOOOO*.........",
		"*OOOOOO*........",
		"*OOOOOOO*.......",
		"*OOOOOOOO*......",
		"*OOOOOOOOO*.....",
		"*OOOOOO*****....",
		"*OO**OO*........",
		"*O*..*OO*.......",
		"**...*OO*.......",
		"*.....***......."
	};
	int x, y;

	for (y = 0; y < 16; y++) {
		for (x = 0; x < 16; x++) {
			if (cursor[y][x] == '*') {
				mouse[y * 16 + x] = COL8_000000;
			}
			if (cursor[y][x] == 'O') {
				mouse[y * 16 + x] = COL8_FFFFFF;
			}
			if (cursor[y][x] == '.') {
				mouse[y * 16 + x] = bc;
			}
		}
	}
	return;
}

unsigned char rgb2pal(int r, int g, int b, int x, int y)
{
	static int table[4] = { 3, 1, 0, 2 };
	int i;
	x &= 1; /*  */
	y &= 1;
	i = table[x + y * 2];	/* ԐF邽߂̒萔 */
	r = (r * 21) / 256;	/*  0`20 ɂȂ */
	g = (g * 21) / 256;
	b = (b * 21) / 256;
	r = (r + i) / 4;	/*  0`5 ɂȂ */
	g = (g + i) / 4;
	b = (b + i) / 4;
	return 16 + r + g * 6 + b * 36;
}

//X^[g{^p̃{^`悷
void put_button(struct SHEET *sht, int ispush)
{
	char *vram = sht->buf;
	int x = sht->bxsize;
	int y = sht->bysize;

	if (ispush == 0) {
		boxfill8(vram, x, COL8_C6C6C6,   0,     0,   x,     y);
		boxfill8(vram, x, COL8_FFFFFF,   0,     0, x-1,     0);
		boxfill8(vram, x, COL8_FFFFFF,   0,     0,   0,   y-1);
		boxfill8(vram, x, COL8_848484,   1,   y-2, x-3,   y-2);
		boxfill8(vram, x, COL8_848484, x-2,     1, x-2,   y-3);
		boxfill8(vram, x, COL8_000000,   0,   y-1, x-2,   y-1);
		boxfill8(vram, x, COL8_000000, x-1,     0, x-1,   y-2);
	} else {
		boxfill8(vram, x, COL8_C6C6C6,   0,     0,   x,     y);
		boxfill8(vram, x, COL8_000000,   0,     0,   x,     0);
		boxfill8(vram, x, COL8_000000,   0,     0,   0,     y);
		boxfill8(vram, x, COL8_848484,   1,     1, x-1,     1);
		boxfill8(vram, x, COL8_848484,   1,     1,   1,   y-1);
		boxfill8(vram, x, COL8_FFFFFF,   1,   y-1, x-2,   y-1);
		boxfill8(vram, x, COL8_FFFFFF, x-1,     1, x-1,   y-2);
	}
	
	sht->flags |= 0x100;
	sheet_refresh(sht, 0, 0, x, y);
	return;
}

void msgbox(char *str, struct SHTCTL *shtctl)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	struct SHEET *sht = sheet_alloc(shtctl);
	unsigned char *buf = (unsigned char *) memman_alloc_4k(memman, 256 * 165);
	sheet_setbuf(sht, buf, 256, 165, -1);
	make_window8(buf, 256, 165, "MGX-Inf", 0);
	sht->task = task_now();
	sht->flags |= 0x05;

	boxfill8(sht->buf, sht->bxsize, COL8_FFFFFF, 8, 27, sht->bxsize - 8, sht->bysize - 8);
	putfonts8_asc(sht->buf, sht->bxsize, 8, 30, COL8_000000, str);

	sheet_slide(sht, 60, 60);
	sheet_updown(sht, shtctl->top);
	return;
}

void delete_taskbar8(unsigned char *vram, int num, int x, int y)
{
	int next = num + 1;
	int a,b;

	boxfill8(vram, x, COL8___BASE, num + 2-1, y - 18-1, num + TaskBar_Window_Size + 2+1, y - 2+1);

	Total_WinMax -= TaskBar_Window_Size + 4;
	return;
}

void insert_taskbar8(unsigned char *vram, char *title, int x, int y)
{
	boxfill8(vram, x, COL8_000000, Total_WinMax + 2-1, y - 18-1, Total_WinMax + TaskBar_Window_Size + 2+1, y - 2+1);
	boxfill8(vram, x, COL8__BASE2, Total_WinMax + 2  , y - 18  ,   Total_WinMax + TaskBar_Window_Size + 2,   y - 2);

	putfonts8_asc(vram, x, Total_WinMax + 8, y - 16, COL8_FFFFFF, title);
	putfonts8_asc(vram, x, Total_WinMax + 9, y - 16, COL8_FFFFFF, title);

	Total_WinMax += TaskBar_Window_Size + 4;
	return;
}
