#include "apilib.h"

#define RGB(r,g,b)		16 + r + g * 6 + b * 36

void Press(int win);
void Screen(int win);

void HariMain(void)
{
	char *buf;
	int win;

	api_initmalloc();
	buf = api_malloc(300 * 200);
	win = api_openwin(buf, 300, 200, -1, "keypress by moge32");	

	Screen(win);
	api_putstrwin(win, 6+9+2, 27+9+2, 17, 28, "L[܂ĂB");

	for (;;) {
		api_getkey(1);
		Press(win);
	}

	api_end();
}

void Press(int win)
{
	static int ct;
	if (ct == 1) {
		api_boxfilwin(win, 6+9+2, 27+18+5, 6+9+2+8, 27+18+5+16, 7);
		api_putstrwin(win, 6+9+2, 27+18+5, 17, 1,"/");
	}else if (ct == 2) {
		api_boxfilwin(win, 6+9+2, 27+18+5, 6+9+2+8, 27+18+5+16, 7);
		api_putstrwin(win, 6+9+2, 27+18+5, 17, 1,"|");
	}else if (ct == 3) {
		api_boxfilwin(win, 6+9+2, 27+18+5, 6+9+2+8, 27+18+5+16, 7);
		api_putstrwin(win, 6+9+2, 27+18+5, 17, 1,"-");
	}else if (ct == 4) {
		api_boxfilwin(win, 6+9+2, 27+18+5, 6+9+2+8, 27+18+5+16, 7);
		api_putstrwin(win, 6+9+2, 27+18+5, 17, 1,"");
	}
	ct++;
	if (ct >= 4) {
		ct = 0;
	}
	return;
}

void Screen(int win)
{
	api_boxfilwin(win, 6, 27, 300 - 8, 200 - 8, 15);
	api_boxfilwin(win, 6+8, 27+8, 300 - 16, 200 - 16, 0);
	api_boxfilwin(win, 6+9, 27+9, 300 - 17, 200 - 17, 7);
	return;
}
