#include "../apilib.h"
#include <stdio.h>

#define RGB(r,g,b)		16 + r + g * 6 + b * 36

void Screen(int win);

void HariMain(void)
{
	char *buf, s[256];
	int win;
	int key;
	int os_type;
	struct SYS_INFO *info;

	api_initmalloc();
	buf = api_malloc(300 * 200);
	win = api_openwin(buf, 300, 200, -1, "SYS-INFO by moge32");	

	Screen(win);
	tomo_sysinfo(info);
	os_type = info->os_type;
	if (os_type == 0) {
		sprintf(s, "Haribote-OS");
	} else if (os_type == 1) {
		sprintf(s, "Hiyos");
	} else if (os_type == 2) {
		sprintf(s, "rapuOS");
	} else if (os_type == 3) {
		sprintf(s, "BayOS");
	} else if (os_type == 4) {
		sprintf(s, "OSAkkie");
	} else if (os_type == 5) {
		sprintf(s, "seriboteOS");
	} else if (os_type == 58) {
		sprintf(s, "MOGEX");
	} else {
		sprintf(s, "???");
	}
	api_putstrwin(win, 6+9+2, 27+9+2, 17, 19, s);

	key = api_getkey(1);
	if (key == 'a')
	{
		Screen(win);
		api_getkey(1);
	}

	api_end();
}

void Screen(int win)
{
	api_boxfilwin(win, 6, 27, 300 - 8, 200 - 8, 15);
	api_boxfilwin(win, 6+8, 27+8, 300 - 16, 200 - 16, 0);
	api_boxfilwin(win, 6+9, 27+9, 300 - 17, 200 - 17, 7);
	return;
}
